'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = promiseToBluebird;
function promiseToBluebird(_ref) {
	var t = _ref.types;

	return {
		visitor: {
			ReferencedIdentifier: function ReferencedIdentifier(path, state) {
				var node = path.node,
				    parent = path.parent,
				    scope = path.scope;


				if (node.name !== 'Promise') return;
				if (t.isMemberExpression(parent)) return;
				if (scope.getBindingIdentifier('Promise')) return;

				path.replaceWith(state.addImport('bluebird', 'default', 'Promise'));
			},
			MemberExpression: function MemberExpression(path, state) {
				var node = path.node;

				var obj = node.object;

				if (obj.name !== 'Promise') return;
				if (!path.isReferenced()) return;
				if (path.scope.getBindingIdentifier('Promise')) return;

				if (node.computed) {
					path.replaceWith(t.memberExpression(state.addImport('bluebird', 'default', 'Promise'), node.property, true));
				} else {
					path.replaceWith(state.addImport('bluebird', node.property.name, 'Promise'));
				}
			}
		}
	};
}

//# sourceMappingURL=main.es5.js.map